----------------------------------------------------------------------------------
-- Company: 
-- Engineer:       Davor Cihlar
-- 
-- Create Date:    22:28:29 06/11/2009 
-- Design Name: 
-- Module Name:    acounter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity acounter is generic (N : integer := 8; init : STD_LOGIC := '1');
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           d : out  STD_LOGIC_VECTOR ((N-1) downto 0));
end acounter;

architecture Behavioral of acounter is
	signal id : STD_LOGIC_VECTOR((N-1) downto 0);
	
	component tbist is generic (init : STD_LOGIC := '1');
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           d : out  STD_LOGIC);
	end component;
begin
	d <= id;
	
	nulti : tbist generic map (init => init)
		port map (clk => clk, rst => rst, d => id(0));

	togleri : for i in 1 to (N-1) generate
		tbgen : tbist generic map (init => init)
			port map (clk => id(i - 1), rst => rst, d => id(i));
	end generate;

end Behavioral;

